#ifndef PARTICLE_H
#define PARTICLE_H

#include "btBulletDynamicsCommon.h"
#include "GL/gl.h"

#include "../../utils/settings.h"
#include "../../utils/displaylists.h"
#include "../../utils/randgen.h"
#include "entity.h"
#include "body.h"

using namespace std;


class Particle : public Entity
{
	public:
		Particle();
		~Particle();

		Body			body;
		void			createBody(btDynamicsWorld* m_dynamicsWorld, const btVector3& startOffset, float r, float g, float b, float a, float xdest, float ydest, float zdest, float speed, float rx, float ry, float rz, unsigned int newtype, float foodlevel, unsigned int newdrugtype, float newdruglevel);

		void			draw();
		
		btScalar		position[16];

 		float			color[5];

//		unsigned int		lifetime;
//		float			energyLevel;
		unsigned int		totalFrames;
		unsigned int		maxLifetime;
		float			energyLevel;
		unsigned int		drugtype;
		float			druglevel;
		bool			killme;
		
		float			size;
//		unsigned int		molecule; // 0 to 3 [0 inhibitory antagonist, 1 inhibitory agonist, 2 excitatory antagonist, 3 excitatory agonist]
//		bool			alive;
//		Particle*			real_particle;
//		Particle*			dummy_particle;
		RandGen                 *randgen;
		btDefaultMotionState* myMotionState;
	private:
		Settings		*settings;

		btBoxShape* boxShape;
		btVector3 halfExtent;
};


#endif
