#include "statsbuffer.h"

Statsbuffer* Statsbuffer::Instance () 
{
	static Statsbuffer t;
	return &t;
}

Statsbuffer::Statsbuffer()
{
	settings = Settings::Instance();

	recordInterval = 50; // was 100 (flamoot) then 2000
	framecounter = 0;
	maxSnapshots = 2500;  // was 3000(flamoot) then 15000 (long!)
}

void Statsbuffer::add()
{
	if ( ++framecounter == recordInterval )
	{
		// remove expired snapshots
		if ( snapshots.size() == maxSnapshots )
			snapshots.erase(snapshots.begin());

		// insert a new snapshot
		snapshots.push_back(statsSnapshot());
		statsSnapshot* s = &snapshots[snapshots.size() - 1];

		s->critters		= settings->info_critters;
		s->food			= settings->info_food;
		s->ad			= settings->info_Graph_ad;
//		if (s->ad < 3701) s->ad = 3701; // flamoot (remove this)
		s->avgneur		= settings->info_Graph_avgneur;
		s->avgsyn		= settings->info_Graph_avgsyn;
		s->synvneur		= settings->info_Graph_synvneur;

		s->drugonelev		= (float) settings->info_drugonelev / (float) settings->info_drugtotlev;
		s->drugtwolev		= (float) settings->info_drugtwolev / (float) settings->info_drugtotlev;
		s->drugthrlev		= (float) settings->info_drugthrlev / (float) settings->info_drugtotlev;
		s->drugfoulev		= (float) settings->info_drugfoulev / (float) settings->info_drugtotlev;
		s->drugfivlev		= (float) settings->info_drugfivlev / (float) settings->info_drugtotlev;
		s->drugtotlev		= (float) settings->info_drugtotlev;
		
		framecounter = 0;

		// debug output
/*		cerr << endl;
		for ( unsigned int i=0; i < snapshots.size(); i++ )
			cerr << "c: " << snapshots[i].critters << ", f: " << snapshots[i].food << endl;*/
	}
}
